#!/bin/sh

#
# Airex, airex@tiscali.it
#
# slacky2bw46.sh update  --> update file lists
# slacky2bw64.sh search_upgrade <log_only> --> search if packages must be upgraded
# slacky2bw46.sh search <package> --> search fot the specified string
# slacky2bw46.sh getbin <package_bin_url> --> retrieve binary package
# slacky2bw46.sh getsrc <package_src_url> --> retrive sources for the package, including SlackBuild
# slacky2bw46.sh gen_slackbuild <package_build_src> --> create the new SlackBuild, make your changes to this file before building it
# slacky2bw46.sh buildsrc <package_build_src> --> build package using the "new" Slackbuild and sources downloaded 
#

THIS_VERSION=20080317


# location of the config file
CONF_FILE=./slacky2bw64.conf
. $CONF_FILE

OD=`pwd`
cd $WORKING_DIR

PKG=$2

SHOW_USAGE=1

echo 


if [ "$1" == "update" ];then

   rm $FILELIST
   wget $SLACKY_FILELIST
   rm $MANIFEST
   wget $SLACKY_MANIFEST
   bzip2 -d ${MANIFEST}.bz2

   SHOW_USAGE=0

fi


if [ "$1" = "search" ]; then

    FND=0    
    SRC=`grep -i "$PKG" $FILELIST|grep "/src$"|sed -es/.*\ \.//|sed -es/[/]src$//`
    OUT=`grep -i "$PKG" $FILELIST|grep ".tgz"|sed -es/.*\ \.//`
    for L in $OUT;
    do
	FND=1
	echo $PKG bin_url: $SLACKY_REP$L
    done
    for L in $SRC;
    do
	FND=1
	echo $PKG src_url: $L
    done
    
    if [ $FND = 0 ]; then
	echo "Nothing found for '$PKG'"
    fi
    
    echo ""
    SHOW_USAGE=0

fi

if [ "$1" = "search_upgrade" ]; 
then

 #   rm BW64_MANIFEST
#    wget $BW64_MANIFEST -O BW64_MANIFEST.bz2
#    bzip2 -d BW64_MANIFEST.bz2
    SHOW_USAGE=0
    
    LOG_ONLY=$2
    LOG_FILE="search_upgrade.commands"
    if [ "$LOG_ONLY" != "" ]; then
	echo > $LOG_FILE
    fi
    
    if [ ! -e $MANIFEST ]; then
	    echo "Not found Slacky MANIFEST!"
	    echo ""
	    exit 
    fi

    SL_PKGS=$(grep "Package:" $MANIFEST | grep -v Old/ | sed -es/.*\\///)
    #BW_PKGS=$(grep "Package:" BW64_MANIFEST | grep bluewhite64-{$SLACKY_VER} | grep -v Old/ | sed -es/.*\\///)
    BW_PKGS=$(grep "Package:" BW64_MANIFEST | grep -v Old/ | sed -es/.*\\///)

    TMP=""
    for P1 in $BW_PKGS; do
	echo "Step1: $P1"
	P=$(echo $P1|sed -es/\-\[0-9\].*\$//)
	if [ "$(echo $TMP|grep -e "$P-[0-9]")" = "" ]; 
	then
	    PG=$P1
	    for i in $BW_PKGS; do
		if [ "$(echo $i|grep -e "$P-[0-9]")" != "" ]; then
		    if [ "$i" \> "$PG" ]; then
			PG=$i
		    fi    		
		fi
	    done    
	    if [ "$(echo $TMP|grep $PG)" = "" ]; then
	        TMP="$TMP $PG"
	    fi
	fi
    done
    
    BW_PKGS=$TMP

    tot=0
    
    UPGR=""
    
    for P1 in $BW_PKGS ; do
	echo "Step2: $P1"
	P=$(echo $P1|sed -es/\-\[0-9\].*\$//)
	x=$(echo ${SL_PKGS} 2> /dev/null|egrep -o "$P-[0-9]+")
	if [ "$x" != "" ]; then
	    p=""
	    x=$(echo $x|sed -es/\-\[0-9\]//|sed -es/\ .*//)
	    x=$(echo $SL_PKGS|egrep -o "$x-[0-9]+"|sort)
	    for i in $x; do
		t=$(echo $i|sed -es/\-\[0-9\]//|sed -es/-.*tgz$//)
		if [ "$t" = $P ]; then
		    p=$i
		fi
	    done
	    #echo "sed -es/^.*${p}/${p}/|sed -es/tgz.*/tgz/"
	    sl=$(echo $SL_PKGS|sed -es/^.*${p}/${p}/|sed -es/tgz.*/tgz/)
	    xP1=$(echo $P1|sed -es/x86_64-//)
	    xsl=$(echo $sl|sed -es/i386-//|sed -es/i486-//|sed -es/i686-//|sed -es/i686-//|sed -es/noarch-//)
	    xsl=`echo ${xsl}|sed -es/[^0-9]*$//g`
	    xP1=`echo ${xP1}|sed -es/[^0-9]*$//g`
	    if [ "$xP1" \< "$xsl" ]; then
		if [ "$xsl" = "" ]; then
		    echo "++ BW $P1"
		else
		    echo "< BW $P1 ; SL: $sl" 
		    sl=$(echo $sl|sed -es/\.tgz//) # |sed -es/\-[0-9].*$//)
		    #echo $sl
		    RISP=""
		    if [ "$LOG_ONLY" != "" ];
		    then
			RISP="y"
		    fi
		    while [[ "$RISP" != "y" && "$RISP" != "n" ]];
		    do
			echo "-- Do you want to upgrade the packages? (y/n)" 
			read RISP
		    done
		    if [ "$RISP" = "y" ];
		    then
			if [ "$LOG_ONLY" != "" ];
			then
			    UPGR="${UPGR}${sl}^${P1} "
			else
			    UPGR="${UPGR}$sl "
			fi
		    fi
		    RISP=""
		fi
	    else
		echo ">= BW $P1 ; SL: $sl"
	    fi
	fi
    done
    
    if [ "$UPGR" = "" ]; then

	echo "No packages to upgrade"

    else
    
	for pk in $UPGR ; do
	    
	    oldpk=$(echo $pk|cut -d^ -f 2)
	    pk=$(echo $pk|cut -d^ -f 1)
	    
	    ver=$(echo $pk|sed -es/-i486.*$//|sed -es/-i586.*$//|sed -es/-i686.*$//|sed -es/-i386.*$//|sed -es/-x86_64.*$//|sed -es/-noarch.*$//)
	    ver=$(echo $ver|sed -es/^.*\-//)
	    smallpk=$(echo $pk|sed -es/\-.*$//)
	    	    
	    pk1=$(echo $pk|sed -es/\.tgz//|sed -es/\-[0-9].*$//)
	    src=$(./slacky2bw64.sh search "$pk1" |grep src|grep "$ver"|sort -r|head -n 1)
	    if [ "$src" = "" ]; then
		echo $smallpk $ver
		src=$(./slacky2bw64.sh search "$smallpk" |grep src|grep "$ver"|sort -r|head -n 1)
	    fi
	    
	    echo $pk
	    
	    if [ "$src" != "" ]; then

		if [ "$LOG_ONLY" != "" ];
		then
		    pack=$(echo $src|sed -es/.*:\ //)
		    echo "# Get $pack: OLD = $oldpk | NEW = $pk" >> $LOG_FILE
		    echo "./slacky2bw64.sh getsrc $pack" >> $LOG_FILE
		    VER=`basename $pack`
		    PKG=`dirname $pack`
		    sb="${PKG}-${VER}"		
		    sb=$(echo $sb|sed -es/^\\/.*\\///)
		    echo "# Make SlackBuild $sb" >> $LOG_FILE
		    echo "./slacky2bw64.sh gen_slackbuild $sb" >> $LOG_FILE
		    echo "" >> $LOG_FILE
		else
		    pack=$(echo $src|sed -es/.*:\ //)
		    echo "Get $pack"
		    ./slacky2bw64.sh getsrc $pack
		    VER=`basename $pack`
		    PKG=`dirname $pack`
		    sb="${PKG}-${VER}"		
		    sb=$(echo $sb|sed -es/^\\/.*\\///)
		    echo "Make SlackBuild $sb"
		    ./slacky2bw64.sh gen_slackbuild $sb
		fi
	    fi
	    
	done
    
    fi
    

fi

if [ "$1" = "getbin" ];
then
    if [ "$2" != "" ];
    then
	rm `basename $2` 2>/dev/null
        wget $2
    fi
fi

if [ "$1" = "getsrc" ];
then
    if [ "$2" != "" ];
    then
	SRC=$2 #/src
	VER=`basename $2`
	PKG=`dirname $2`
	PKG=`basename $PKG`
	FILES=`grep " .$SRC" $FILELIST|grep src|grep -v "/src$"|sed -es/.*\ \.//`

	PKGDIR="${PKG}-${VER}"
	rm -rf $PKGDIR 2>/dev/null
	mkdir $PKGDIR
	cd $PKGDIR
	for FILE in $FILES;
	do
	    wget ${SLACKY_REP}${FILE}
	done
	cd ..
	
	echo "$PKGDIR, now you can create the modified version of *.SlackBuild"
	
	SHOW_USAGE=0
    fi
fi




if [ "$1" = "gen_slackbuild" ];
then
    for SLACKBUILD in $2/*.SlackBuild; do
	    cp  $SLACKBUILD  ${SLACKBUILD}.Slacky
	    echo "#Repackaged by $PACKAGER" > ___sb
	    cat $SLACKBUILD >> ___sb
    	    cat ___sb|sed -es/^CHOST=.*$/CHOST=x86_64/ > ___sb2
    	    mv ___sb2 ___sb
    	    cat ___sb|sed -es/-slackware-linux/-pc-linux/ > ___sb2
    	    mv ___sb2 ___sb	    
	    cat ___sb|sed -es/^TARGET=.*$/TARGET=x86_64/ > ___sb2
	    mv ___sb2 ___sb
	    cat ___sb|sed -es/^ARCH=.*$/ARCH=x86_64/ > ___sb2
	    mv ___sb2 ___sb
	    cat ___sb|sed -r -es/march=\([[:alnum:]_-]*\)/march=x86-64\ / >___sb2
	    mv ___sb2 ___sb
	    cat ___sb|sed -r -es/mtune=\([[:alnum:]_-]*\)/mtune=x86-64\ / >___sb2
	    mv ___sb2 ___sb	    
	    cat ___sb|sed -r -es/mcpu=\([[:alnum:]_-]*\)/mcpu=x86-64\ / >___sb2
	    mv ___sb2 ___sb	    
	    cat ___sb|sed -es/^CFLAGS=/SLKCFLAGS=\"-O2\ -fPIC\ -march=x86-64\ -mtune=x86-64\ -mfpmath=sse\ -mmmx\ -msse\ -msse2\"\\nCFLAGS=/ > ___sb2
	    mv ___sb2 ___sb
	    mv ___sb $SLACKBUILD
    done
    
    echo "$2, now you can build the source ( build_src: $2 ) "
    
    SHOW_USAGE=0
fi

if [ "$1" = "buildsrc" ];
then
    if [ "$2" != "" ]; then
	DIR=$2
	cd $DIR
	REQS=`cat $SLACK_REQUIRED|sed -es/\ /##/g`
	for REQ in $REQS;
	do
	    REQ_P=0
	    REQ_MISSING=0
	    TREQ=`echo "$REQ"|sed -es/\|/\ /g`
	    for XR in $TREQ
	    do
		XR=`echo "$XR"|sed -es/##//g`
		# ok, we have packname>=packvers
		XR_NAME=`echo "$XR"|sed -es/\>.*$//`
		XR_VER=`echo "$XR"|sed -es/.*\>=//|sed -es/-.*//`
		PRES=""
		PRES=`ls /var/log/packages/${XR_NAME}-${XR_VER}-x86_64* 2>/dev/null`
		if [ "$PRES" = "" ]; then
		    PRES=`echo ${XR_VER} | egrep "^[0-9]"`
		    START_VER="[0-9]"
		    if [ "$PRES" = "" ]; then
			START_VER="[^0-9]"
		    fi
		    PRES=`ls /var/log/packages/${XR_NAME}-*-x86_64* | egrep "${XR_NAME}-${START_VER}" 2>/dev/null`
		fi
		#echo "$XR---$PRES"
		echo ""
		echo "Checking for $XR_NAME-$XR_VER"
		if [ "$PRES" = "" ];
		then
		    REQ_MISSING=1
		    echo "Missing $XR_NAME $XR_VER ... maybe not a fatal error if this in one item of an \"OR\" list"
		    continue
		fi
		PRES_NAME=`basename $PRES|sed -es/\-x86.*$//|sed -es/-.*$//`
		PRES_VER=`basename "$PRES"|sed -es/${PRES_NAME}-//|sed -es/-x86.*$//`
		tXR_NUMBERS=`echo $XR_VER|sed -es/[.]/\ /g`
		tPRES_NUMBERS=`echo $PRES_VER|sed -es/[.]/\ /g`
		X=0
		for tX in $tXR_NUMBERS;
		do
		  XR_NUMBERS[$X]=$tX      
		  X=$(($X+1))
		done
		XR_NUMBERS_LEN=$X
		X=0
		for tX in $tPRES_NUMBERS;
		do
		  PRES_NUMBERS[$X]=$tX      
		  X=$(($X+1))
		done
		OK_LIB=1
		X=0
		while [ 1 ];
		do
		    PNl=`echo ${PRES_NUMBERS[$X]}|sed -es/[0-9]*//`
		    XNl=`echo ${XR_NUMBERS[$X]}|sed -es/[0-9]*//`
		    USE_STR=0
		    DELTA_NEG=
		    if [ "$PNl" != "" ]; then
			USE_STR=1
		    fi
		    if [ "$XNl" != "" ]; then
			USE_STR=1
		    fi
		    if [ "$USE_STR" = "1" ]; then
			if [[ "${PRES_NUMBERS[$X]}" < "${XR_NUMBERS[$X]}" ]]; then
			    DELTA_NEG="-"
			fi
		    fi
		    if [ "$USE_STR" = "0" ]; then
			DELTA=$((${PRES_NUMBERS[$X]}-${XR_NUMBERS[$X]}))
			DELTA_NEG=`echo $DELTA|head -c 1`
		    fi	    
		    if [ "$DELTA_NEG" = "-" ]; then
			OK_LIB=0
			break;
		    fi
		    X=$(($X+1))
		    END=$(($XR_NUMBERS_LEN-$X))    
		    if [ "$END" = "0" ]; then 
			break
		    fi
		done
		if [ "$OK_LIB" = "0" ]; then
		    REQ_MISSING=1
		fi
		if [ "$OK_LIB" = "1" ]; then
		    REQ_MISSING=0
		    echo "$PRES_NAME-$PRES_VER OK ($XR_NAME-$XR_VER)!"
		    break
		fi
		REQ_P=$(($REQ_P + 1))
	    done
	    if [ "$REQ_MISSING" = "1" ];
	    then
		echo "Fatal missing packages!"
		echo "Check out for last missing package"
		exit
	    fi
	done
	# exit used in debug 
	# exit	
	for SLACKBUILD in *.SlackBuild; do
	    sh $SLACKBUILD --cleanup
	done
	cd ..
	SHOW_USAGE=0
    fi
fi


if [ "$1" = "searchfile" ]; then

    echo "Looking for $PKG into $MANIFEST"
    
    SHOW_USAGE=0

fi

if [ $SHOW_USAGE = 1 ]; then
 echo "Usage:"
 echo ""
 echo "slacky2bw46.sh update"
 echo "slacky2bw46.sh search <package>"
 echo "slacky2bw64.sh search_upgrade "
 echo "slacky2bw46.sh getbin <package_bin_url>"
 echo "slacky2bw46.sh getsrc <package_src_url>"
 echo "slacky2bw46.sh gen_slackbuild <package_build_src>"
 echo "slacky2bw46.sh buildsrc <package_build_src>"
fi



echo ""

cd $OD

